#!/bin/perl

use IO::Seekable;

$current_date = `date +"%Y-%m-%d"`;
$date = substr($current_date,0,-1);

my $logfile="/logs/gateway/ssg.$date.log";
#my $logfile="/axphome/vkthaku/ssg.$date.log";
my $accessposfile="/var/tmp/.ssg.Layer7-Api-Hits.pos";
my $accessseek="/var/tmp/.ssg.Layer7-Api-Hits.log";
my $pidfile="/var/tmp/.ssg.Layer7-Api-Hits.pid";

my $process = `ps -ef|grep -iv grep |grep -i epagent|awk '{ print $2 }'`;
@pid=split(' ',$process);
$newpid=$pid[1];


if(! (-e $pidfile && -s $pidfile) )
{
open(PIDFILE,">$pidfile") or die "Cannot open PID File to Write\n";
 print PIDFILE $newpid;
}

open(PIDFILE,"<$pidfile") or die "Cannot open PID file to Read\n";


while(<PIDFILE>)
{
    $oldpid=$_;
}

close PIDFILE;

if ($newpid ne $oldpid)
{
 open(PIDFILE,">$pidfile") or die "Cannot open PID File to Write\n";
  print PIDFILE $newpid;

 if( -e $accessposfile)
   {
     unlink $accessposfile;
   }
}

## Checking the EOF for the first time or if position file does not exist.
open(ACCESSFILE,"< $logfile") or die "ACCESS log file do not exists\n";

if(! (-e $accessposfile && -s $accessposfile) )
{
    while(<ACCESSFILE>) {
         $addr = tell(ACCESSFILE) unless eof(ACCESSFILE);
    }
   open(POSFILE,">$accessposfile") or die "Cannot open Position file\n";
   print POSFILE $addr;
   close POSFILE;
   close ACCESSFILE;
   exit 0;
}

## Fetch the last read positon.
## Fix required for new access log file spawning conditions.

open(POSFILE,"<$accessposfile") or die "Cannot open L Position file\n";

while(<POSFILE>)
{
    $addr=$_;
}

close POSFILE;

## $addr should be greater than file size

my $fileSize = -s $logfile;

if($addr > $fileSize)
{
    # Assume log file rotation
    $addr=0;

}

## Go to address in ACCESS File.
seek(ACCESSFILE,$addr,0);

## Write to temporary file
open(SEEK,">$accessseek")  or die "Cannot open access seek log";

while(<ACCESSFILE>)
{

    $newaddr = tell(ACCESSFILE) unless eof(ACCESSFILE);
    if($newaddr)
        {
         print SEEK $_;
        }
}
close ACCESSFILE;
close SEEK;


## Fix for no newline

if ($newaddr eq "")
{
    $newaddr=$addr;
}

## write new location to position file

open(POSFILE,">$accessposfile") or die "Cannot open LL Position file\n";
    print POSFILE $newaddr;

close POSFILE;

# PRINT TOTAL REQUESTS FROM THE SEEK LOG

open(SEEKFILE,"<$accessseek") or die "Cannot open SEEK file\n";

$count=0;
$count1=0;
$totalcount=0;


while(<SEEKFILE>) {

$data=$_;


if($data =~ "Start of \/")
{
    $count ++;
    
if($data =~ "start of the" || $data =~ "\/thread_id\/" || $data =~ "\/oauth\/amex\/custom\/dbcalls/" || $data =~ "\/oauth\/tokenstore\/"  || $data =~ "\/oauth\/clientstore\/"  || $data =~ "\/oauth\/validation\/")
{
    $count1 ++;
    
}

}

## While loop ends 

}

close SEEKFILE;

$totalcount=$count - $count1;

# Print Total API Hits

print "<metric type=\"IntCounter\" name=\"Layer7_API_Hits:TOTAL Layer7 API Hits\" value=\"$totalcount\"/>\n";


